// KeyboardDemoDlg.h : header file
//

#if !defined(AFX_KEYBOARDDEMODLG_H__9B5E8D48_ABC6_4CF2_A1DC_7A6F447045B7__INCLUDED_)
#define AFX_KEYBOARDDEMODLG_H__9B5E8D48_ABC6_4CF2_A1DC_7A6F447045B7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../inCn/SerialSDK.h"
#include <vector>
/////////////////////////////////////////////////////////////////////////////
// CKeyboardDemoDlg dialog
#define KEYBOARD_ONLINE    WM_USER + 1  //
#define KEYBOARD_OFFLINE   WM_USER + 2  //

typedef struct _DEV_INFO
{
    char sComName[NAME_LEN];
    WORD wDevType;
    BYTE byRes[2];
    LONG lSerialHandle;
    HANDLE hMessageFinish;
}DEV_INFO,*LPDEV_INFO;

using std::vector;

#define MESSAGE_DEV_ONLINE      WM_USER + 1  //豸Ϣ
#define MESSAGE_DEV_OFFLINE     WM_USER + 2  //豸Ϣ
#define MESSAGE_ADD_MESSAGE     WM_USER + 3  //ֵ̼Ϣ

class CKeyboardDemoDlg : public CDialog
{
// Construction
public:
	CKeyboardDemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CKeyboardDemoDlg)
	enum { IDD = IDD_KEYBOARDDEMO_DIALOG };
	CListCtrl	m_listMessage;
	CListCtrl	m_listDev;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKeyboardDemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CKeyboardDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBtnStartSearch();
	afx_msg void OnBtnStopSearch();
	afx_msg void OnDestroy();
	afx_msg void OnBtnExit();
	afx_msg void OnBtnUpgrade();
	afx_msg void OnButTest();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
    void static CALLBACK Hid_DATA_CB(BYTE *pDevPath, DWORD dwDevPathLen, BYTE byOnOffline, void* pUser);
    void static CALLBACK SerialDataCallback(LONG lSerialHandle, BYTE *pDataBuffer, DWORD dwBufLen, void* pUser);
    void static CALLBACK MessageDataCallBack(LONG lSerialHandle, DWORD dwMsgType, BYTE *pDataBuffer, DWORD dwBufLen, void *pUser);
    void InitList();
    char m_sComName[32];
    vector<DEV_INFO> m_vDevInfo;
    BOOL m_bUpdate;
    BOOL m_bStop;

    CRITICAL_SECTION m_struCritical;    //m_vDevInfo
    CRITICAL_SECTION m_struMessageLock; //Ϣṹ
    CRITICAL_SECTION m_struCallBackLock; //صռ
    CRITICAL_SECTION m_struOnOffLine; //Ϣִ
    HANDLE m_hEvent;    
protected:
    LRESULT ProcessDevOnline(WPARAM wParam, LPARAM lParam);
    LRESULT ProcessDevOffline(WPARAM wParam, LPARAM lParam);
    void InsertDevList(DEV_INFO *struDevInfo, SERIAL_PORT_DEV_INFO *struDev);
    void EraseDevList(DEV_INFO *struDevInfo);
    LRESULT AddMessage(WPARAM wParam, LPARAM lParam);

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KEYBOARDDEMODLG_H__9B5E8D48_ABC6_4CF2_A1DC_7A6F447045B7__INCLUDED_)
